/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Menu Editor.
 *
 * The Initial Developer of the Original Code is
 * Devon Jensen.
 *
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Devon Jensen <velcrospud@hotmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

window.addEventListener("load", menuEditInit, true);
//window.addEventListener('close', menuEditClose, true);

var me_RDFC = '@mozilla.org/rdf/container;1';
me_RDFC = Components.classes[me_RDFC].createInstance();
me_RDFC = me_RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);

var me_RDFCUtils = '@mozilla.org/rdf/container-utils;1';
me_RDFCUtils = Components.classes[me_RDFCUtils].getService();
me_RDFCUtils = me_RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);

var me_RDF = '@mozilla.org/rdf/rdf-service;1';
me_RDF = Components.classes[me_RDF].getService();
me_RDF = me_RDF.QueryInterface(Components.interfaces.nsIRDFService);

var me_datasource;
var me_uri;

function menuEditInit() {
	window.removeEventListener("load", menuEditInit, true);
	//toJavaScriptConsole();
	//BrowserOpenExtensions('extensions');
	
	//d(contextPopup.childNodes.length);
	
	//Get our profile folder uri
	var gIOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	// From TBE
	const DIR = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
	var dir = DIR.get('ProfD', Components.interfaces.nsILocalFile);

	var tempLocalFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
	tempLocalFile.initWithPath(dir.path);

	//me_uri;
	try {
		me_uri = gIOService.newFileURI(tempLocalFile).spec;
	}
	catch(e) {}

	if (!me_uri.match(/\/$/)) me_uri += '/';
	// from TBE
	//d(me_uri);
	
	var me_defaultMenu = document.getElementById("contentAreaContextMenu").cloneNode(true);
	me_defaultMenu.id = "contextMenuBackup";
	
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	try {
		var savedNum = pref.getIntPref("menuedit.current.menuitems");
	} catch(e){}
	//d("from pref: " + savedNum);
	//d("default menu length: " + me_defaultMenu.childNodes.length);
	
	if (!savedNum == 0) {
		moveToTemp();
		populateMenu();
		if (savedNum < me_defaultMenu.childNodes.length)
			discoverNew(me_defaultMenu.childNodes.length);  // do this after movetotemp and populatemenu so we only have to iterate through those left over
	}
	else {  // First run
		// Do nothing, wait for the options to be run.
		//d("firstrun");
	}

	//var browser = document.getElementById("content");
	//browser.setAttribute("contentcontextmenu", "EM_contentAreaContextMenu");
}

function populateMenu() {
	var contextPopup = document.getElementById("contentAreaContextMenu");
	var EM_contextPopup = document.getElementById("EM_contentAreaContextMenu");
	
	me_datasource = me_RDF.GetDataSourceBlocking(me_uri + "menuedit.rdf");
	var root = me_RDF.GetResource("NC:ContextRoot");
	var rootCont = me_RDFCUtils.MakeSeq(me_datasource,root);
	//d("items in database: " + rootCont.GetCount());
	//d("context menu length " + contextPopup.childNodes.length);
	
	var allElem = rootCont.GetElements();
	var child, fullRef, elemID, elem, clone, showRef;
	var arcShow = me_RDF.GetResource("http://home.netscape.com/NC-rdf#show");
	
	while (allElem.hasMoreElements()){
		child = allElem.getNext();
		try {
			fullRef = child.QueryInterface(Components.interfaces.nsIRDFResource).ValueUTF8;
		
			showRef = me_datasource.GetTarget(child, arcShow, true);
			show = showRef.QueryInterface(Components.interfaces.nsIRDFInt).Value;	
		} catch(e){}
		
		//d("showValue:" + show);
		if (show != 0) { // If it is 1 or unknown, show it
			elemID = fullRef.split("#")[1];
			//d(elemID);
			elem = document.getElementById(elemID);
			try {
				contextPopup.appendChild(elem);
			} catch(e){ // if this errors, there is no element with that id - need to remove the offending entry from the database
				removeBadEntry(fullRef);
			}
		}
		
	}
	//d("(end populate) context menu length " + contextPopup.childNodes.length);
}

// Move all the menu items from contentAreaContextMenu over to the temporary EM_contentAreaContextMenu
function moveToTemp() {
	var elem;
	var contextPopup = document.getElementById("contentAreaContextMenu");
	var EM_contextPopup = document.getElementById("EM_contentAreaContextMenu");
	//d("before " + contextPopup.childNodes.length);
	//d("before " + EM_contextPopup.childNodes.length);
	var oldChildNodes = contextPopup.childNodes;
	for (var i = 0; i <= oldChildNodes.length - 1; ++i) {
		//d("here " + i);
		elem = contextPopup.removeChild(oldChildNodes[i]);
		EM_contextPopup.appendChild(elem);
	}
	//d("after " + contextPopup.childNodes.length);
	//d("after " + EM_contextPopup.childNodes.length)
	
}

function discoverNew(newlength) {
	//d("indiscover");
	
	if (!newlength)
		newlength = document.getElementById("contextMenuBackup").childNodes.length;
	var root = me_RDF.GetResource("NC:ContextRoot");
	var rootCont = me_RDFCUtils.MakeSeq(me_datasource, root);
	var arcShow = me_RDF.GetResource("http://home.netscape.com/NC-rdf#show");
	var arcName = me_RDF.GetResource("http://home.netscape.com/NC-rdf#name");
	var showLit = me_RDF.GetIntLiteral(1);
		
		var EM_contextPopup = document.getElementById("EM_contentAreaContextMenu");  // anything new will be left on here after movetotemp and populatemenu
		var contextPopup = document.getElementById("contentAreaContextMenu");
		var childNodes = EM_contextPopup.childNodes;
		var tempRes, currentLabel, name;
		
		//d(childNodes.length);
		for (var i = 0; i <= childNodes.length - 1; ++i) {
			//d("here " + i + " : " + childNodes[i].id);
			tempRes = me_RDF.GetResource("http://home.netscape.com/NC-rdf#" + childNodes[i].id);
			
			if (rootCont.IndexOf(tempRes) == -1) {  // returns -1 if it is not in the container, it's new
				//d("New item: " + childNodes[i].id);
				rootCont.AppendElement(tempRes);
				
				currentLabel = childNodes[i].label;
				if (currentLabel && currentLabel != "")
					name = currentLabel;
				else
					name = childNodes[i].id;
				
				nameLit = me_RDF.GetLiteral(name);
				me_datasource.Assert(tempRes, arcShow, showLit, true);
				me_datasource.Assert(tempRes, arcName, nameLit, true);
				
				contextPopup.appendChild(childNodes[i]);
				//d("appended");
			}
		}
		
		var rdfsource = me_datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
		rdfsource.Flush();
		
		var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		try {
			pref.setIntPref("menuedit.current.menuitems", newlength);
			//d("prefset: " + newlength);
		} catch (e){}
		//nodeName // gives type of element, e.g. button, menuitem, textbox, etc.
			

}

function removeBadEntry(badRef) {
	//d("inremovebad: " + badRef);
	var root = me_RDF.GetResource("NC:ContextRoot");
	var rootCont = me_RDFCUtils.MakeSeq(me_datasource, root);
	var node = me_RDF.GetResource(badRef);
	rootCont.RemoveElement(node, true);
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	try {
		var oldnum = pref.getIntPref("menuedit.current.menuitems");
		oldnum--;
		pref.setIntPref("menuedit.current.menuitems", oldnum);
		//d("prefset: " + oldnum);
	} catch (e){}
	window.setTimeout("menuEditInit()", 100);  // need to restart because the loop in populateMenu was interrupted
	var rdfsource = me_datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	rdfsource.Flush();
	//d("done");
	
}

function menuEditClose() {
	//d("close");

}
/*
// Dump a message to Javascript Console
function d(msg){
	var acs = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	acs.logStringMessage(msg);
}*/